
{
Opcodes Flags:
Bit: 7 6 5 4 3 2 1 0
            L OP_MODRM     - MOD r/m present
           L-- OP_DATA_I8   - imm8 operand
          L---- OP_DATA_I16  - imm 16 operand
         L------ OP_DATA_I32  - imm 32 operand
        L-------- OP_DATA_PRE66 - operand PRE66
       L---------- OP_DATA_PRE67 - operand PRE67
      L------------ OP_W
     L-------------- OP_D

Opcodes Flags:
Bit: 15 14 13 12 11 10 9 8
                  L- OP_BYTE (OP_S for base opcodes only)
                 L--- OP_SREG2  (in base opcode only) (OP_MMX in extended opcodes)
                L----- OP_SREG3  (in extended opcode only!) 
              L-------- OP_TTTn  - opcode has condition
            L----------- OP_EEE   - opcode has DR, CR or TR registers  (in extended opcodes only!)
          L-------------- OP_WORD  - word size opcode
        L----------------- OP_MNEMDIFF - mnemonic different in 16 and 32 bit modes (16 bit opcode lookup from DifTable), for extended instructions - OP_MNEMEXT
      L-------------------- OP_RD - opcode contain register number
Bits 16-23 - opcode mnemonic ordinal
Opcodes Flags:
Bit: 31 30 29 28 27 26 25 24
                   L modrm used bit
                 L--- OP_REV - always reversing operands
                L----- OP_ONE - one param in MOD 11
              L-------- OP_THREE - three params in opcode           
            L------------ OP_SSE - sse instruction
          L--------------- OP_SSE_PFX - use rep prefix for SSE instruction
        L-----------------
      L--------------------
}
const
 OP_NONE       = 0 shl 0; 
 OP_MODRM      = 1 shl 0;
 OP_DATA_I8    = 1 shl 1;
 OP_DATA_I16   = 1 shl 2;
 OP_DATA_I32   = 1 shl 3;
 OP_DATA_PRE66 = 1 shl 4;
 OP_DATA_PRE67 = 1 shl 5;
 OP_W          = 1 shl 6;
 OP_D          = 1 shl 7;
 OP_S          = 1 shl 8;
 OP_BYTE       = 1 shl 8;
 OP_SREG2      = 1 shl 9;
 OP_MMX        = 1 shl 9;
 OP_SREG3      = 1 shl 10;
 OP_TTTn       = 1 shl 11;
 OP_EEE        = 1 shl 12;
 OP_WORD       = 1 shl 13;
 OP_MNEMDIFF   = 1 shl 14;
 OP_MNEMEXT    = 1 shl 14;
 OP_RD         = 1 shl 15;
 OP_MODRM_USED = 1 shl 24;
 OP_REV        = 1 shl 25;
 OP_ONE        = 1 shl 26;
 OP_THREE      = 1 shl 27;
 OP_SSE        = 1 shl 28;
 OP_SSE_PFX    = 1 shl 29;

const
 OpcodeFlags: array [$00..$FF] of dword =
 (
  OP_MODRM or ($62 shl 16) or OP_W or OP_D,                    // 00
  OP_MODRM or ($62 shl 16) or OP_W or OP_D,                    // 01
  OP_MODRM or ($62 shl 16) or OP_W or OP_D,                    // 02
  OP_MODRM or ($62 shl 16) or OP_W or OP_D,                    // 03
  OP_DATA_I8 or ($62 shl 16) or OP_W,                          // 04
  OP_DATA_PRE66 or ($62 shl 16) or OP_W,                       // 05
  ($D8 shl 16) or OP_SREG2,                                    // 06
  ($D9 shl 16) or OP_SREG2,                                    // 07
  OP_MODRM or ($6F shl 16) or OP_W or OP_D,                    // 08
  OP_MODRM or ($6F shl 16) or OP_W or OP_D,                    // 09
  OP_MODRM or ($6F shl 16) or OP_W or OP_D,                    // 0A
  OP_MODRM or ($6F shl 16) or OP_W or OP_D,                    // 0B
  OP_DATA_I8 or ($6F shl 16) or OP_W,                          // 0C
  OP_DATA_PRE66 or ($6F shl 16) or OP_W,                       // 0D
  ($D8 shl 16) or OP_SREG2,                                    // 0E
  OP_NONE,                                                     // 0F
  OP_MODRM or ($61 shl 16) or OP_W or OP_D,                    // 10
  OP_MODRM or ($61 shl 16) or OP_W or OP_D,                    // 11
  OP_MODRM or ($61 shl 16) or OP_W or OP_D,                    // 12
  OP_MODRM or ($61 shl 16) or OP_W or OP_D,                    // 13
  OP_DATA_I8 or ($61 shl 16) or OP_W,                          // 14
  OP_DATA_PRE66 or ($61 shl 16) or OP_W,                       // 15
  ($D8 shl 16) or OP_SREG2,                                    // 16
  ($D9 shl 16) or OP_SREG2,                                    // 17
  OP_MODRM or ($70 shl 16) or OP_W or OP_D,                    // 18
  OP_MODRM or ($70 shl 16) or OP_W or OP_D,                    // 19
  OP_MODRM or ($70 shl 16) or OP_W or OP_D,                    // 1A
  OP_MODRM or ($70 shl 16) or OP_W or OP_D,                    // 1B
  OP_DATA_I8 or ($70 shl 16) or OP_W,                          // 1C
  OP_DATA_PRE66 or ($70 shl 16) or OP_W,                       // 1D
  ($D8 shl 16) or OP_SREG2,                                    // 1E
  ($D9 shl 16) or OP_SREG2,                                    // 1F
  OP_MODRM or ($63 shl 16) or OP_W or OP_D,                    // 20
  OP_MODRM or ($63 shl 16) or OP_W or OP_D,                    // 21
  OP_MODRM or ($63 shl 16) or OP_W or OP_D,                    // 22
  OP_MODRM or ($63 shl 16) or OP_W or OP_D,                    // 23
  OP_DATA_I8 or ($63 shl 16) or OP_W,                          // 24
  OP_DATA_PRE66 or ($63 shl 16) or OP_W,                       // 25
  OP_NONE,                                                     // 26
  ($10 shl 16),                                                // 27
  OP_MODRM or ($71 shl 16) or OP_W or OP_D,                    // 28
  OP_MODRM or ($71 shl 16) or OP_W or OP_D,                    // 29
  OP_MODRM or ($71 shl 16) or OP_W or OP_D,                    // 2A
  OP_MODRM or ($71 shl 16) or OP_W or OP_D,                    // 2B
  OP_DATA_I8 or ($71 shl 16) or OP_W,                          // 2C
  OP_DATA_PRE66 or ($71 shl 16) or OP_W,                       // 2D
  OP_NONE,                                                     // 2E
  ($11 shl 16),                                                // 2F
  OP_MODRM or ($72 shl 16) or OP_W or OP_D,                    // 30
  OP_MODRM or ($72 shl 16) or OP_W or OP_D,                    // 31
  OP_MODRM or ($72 shl 16) or OP_W or OP_D,                    // 32
  OP_MODRM or ($72 shl 16) or OP_W or OP_D,                    // 33
  OP_DATA_I8 or ($72 shl 16) or OP_W,                          // 34
  OP_DATA_PRE66 or ($72 shl 16) or OP_W,                       // 35
  OP_NONE,                                                     // 36
  ($00 shl 16) or OP_D,                                        // 37
  OP_MODRM or ($6C shl 16) or OP_W or OP_D,                    // 38
  OP_MODRM or ($6C shl 16) or OP_W or OP_D,                    // 39
  OP_MODRM or ($6C shl 16) or OP_W or OP_D,                    // 3A
  OP_MODRM or ($6C shl 16) or OP_W or OP_D,                    // 3B
  OP_DATA_I8 or ($6C shl 16) or OP_W,                          // 3C
  OP_DATA_PRE66 or ($6C shl 16) or OP_W,                       // 3D
  OP_NONE,                                                     // 3E
  ($03 shl 16),                                                // 3F
  ($9C shl 16) or OP_RD,                                       // 40
  ($9C shl 16) or OP_RD,                                       // 41
  ($9C shl 16) or OP_RD,                                       // 42
  ($9C shl 16) or OP_RD,                                       // 43
  ($9C shl 16) or OP_RD,                                       // 44
  ($9C shl 16) or OP_RD,                                       // 45
  ($9C shl 16) or OP_RD,                                       // 46
  ($9C shl 16) or OP_RD,                                       // 47
  ($9B shl 16) or OP_RD,                                       // 48
  ($9B shl 16) or OP_RD,                                       // 49
  ($9B shl 16) or OP_RD,                                       // 4A
  ($9B shl 16) or OP_RD,                                       // 4B
  ($9B shl 16) or OP_RD,                                       // 4C
  ($9B shl 16) or OP_RD,                                       // 4D
  ($9B shl 16) or OP_RD,                                       // 4E
  ($9B shl 16) or OP_RD,                                       // 4F
  ($D8 shl 16) or OP_RD,                                       // 50
  ($D8 shl 16) or OP_RD,                                       // 51
  ($D8 shl 16) or OP_RD,                                       // 52
  ($D8 shl 16) or OP_RD,                                       // 53
  ($D8 shl 16) or OP_RD,                                       // 54
  ($D8 shl 16) or OP_RD,                                       // 55
  ($D8 shl 16) or OP_RD,                                       // 56
  ($D8 shl 16) or OP_RD,                                       // 57
  ($D9 shl 16) or OP_RD,                                       // 58
  ($D9 shl 16) or OP_RD,                                       // 59
  ($D9 shl 16) or OP_RD,                                       // 5A
  ($D9 shl 16) or OP_RD,                                       // 5B
  ($D9 shl 16) or OP_RD,                                       // 5C
  ($D9 shl 16) or OP_RD,                                       // 5D
  ($D9 shl 16) or OP_RD,                                       // 5E
  ($D9 shl 16) or OP_RD,                                       // 5F
  ($49 shl 16) or OP_MNEMDIFF,                                 // 60
  ($45 shl 16) or OP_MNEMDIFF,                                 // 61
  OP_MODRM or ($65 shl 16),                                    // 62
  OP_MODRM or ($64 shl 16),                                    // 63
  OP_NONE,                                                     // 64
  OP_NONE,                                                     // 65
  OP_NONE,                                                     // 66
  OP_NONE,                                                     // 67
  OP_DATA_PRE66 or ($D8 shl 16) or OP_S,                       // 68
  OP_MODRM or OP_DATA_PRE66 or ($88 shl 16) or OP_THREE,       // 69
  OP_DATA_I8 or ($D8 shl 16) or OP_S,                          // 6A
  OP_MODRM or OP_DATA_I8 or ($88 shl 16) or OP_THREE,          // 6B
  ($31 shl 16) or OP_W,                                        // 6C
  ($33 shl 16) or OP_W or OP_MNEMDIFF,                         // 6D
  ($41 shl 16) or OP_W,                                        // 6E
  ($43 shl 16) or OP_W or OP_MNEMDIFF,                         // 6F
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 70
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 71
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 72
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 73
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 74
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 75
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 76
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 77
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 78
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 79
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 7A
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 7B
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 7C
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 7D
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 7E
  OP_DATA_I8 or OP_TTTn or ($D6 shl 16),                       // 7F
  OP_MODRM or OP_DATA_I8 or OP_MODRM_USED or OP_W or OP_S,     // 80
  OP_MODRM or OP_DATA_PRE66 or OP_MODRM_USED or OP_W or OP_S,  // 81
  OP_MODRM or OP_DATA_I8 or ($63 shl 16) or OP_W or OP_S,      // 82
  OP_MODRM or OP_DATA_I8 or OP_MODRM_USED or OP_W or OP_S,     // 83
  OP_MODRM or ($8A shl 16) or OP_W,                            // 84
  OP_MODRM or ($8A shl 16) or OP_W,                            // 85
  OP_MODRM or ($95 shl 16) or OP_W,                            // 86
  OP_MODRM or ($95 shl 16) or OP_W,                            // 87
  OP_MODRM or ($96 shl 16) or OP_W or OP_D,                    // 88
  OP_MODRM or ($96 shl 16) or OP_W or OP_D,                    // 89
  OP_MODRM or ($96 shl 16) or OP_W or OP_D,                    // 8A
  OP_MODRM or ($96 shl 16) or OP_W or OP_D,                    // 8B
  OP_MODRM or ($96 shl 16) or OP_SREG3 or OP_D,                // 8C
  OP_MODRM or ($74 shl 16),                                    // 8D
  OP_MODRM or ($96 shl 16) or OP_SREG3 or OP_D,                // 8E
  OP_MODRM or OP_MODRM_USED or OP_ONE,                         // 8F
  ($40 shl 16) or OP_RD,                                       // 90
  ($95 shl 16) or OP_RD,                                       // 91
  ($95 shl 16) or OP_RD,                                       // 92
  ($95 shl 16) or OP_RD,                                       // 93
  ($95 shl 16) or OP_RD,                                       // 94
  ($95 shl 16) or OP_RD,                                       // 95
  ($95 shl 16) or OP_RD,                                       // 96
  ($95 shl 16) or OP_RD,                                       // 97
  ($04 shl 16) or OP_MNEMDIFF,                                 // 98
  ($0F shl 16) or OP_MNEMDIFF,                                 // 99
  OP_DATA_I32 or OP_DATA_I16 or ($9A shl 16),                  // 9A
  ($58 shl 16),                                                // 9B
  ($4B shl 16),                                                // 9C
  ($47 shl 16),                                                // 9D
  ($4E shl 16),                                                // 9E
  ($38 shl 16),                                                // 9F
  OP_DATA_PRE67 or ($96 shl 16) or OP_W or OP_D,               // A0
  OP_DATA_PRE67 or ($96 shl 16) or OP_W or OP_D,               // A1
  OP_DATA_PRE67 or ($96 shl 16) or OP_W or OP_D,               // A2
  OP_DATA_PRE67 or ($96 shl 16) or OP_W or OP_D,               // A3
  ($3D shl 16) or OP_W,                                        // A4
  ($3F shl 16) or OP_MNEMDIFF or OP_W,                         // A5
  ($0B shl 16) or OP_W,                                        // A6
  ($0D shl 16) or OP_MNEMDIFF or OP_W,                         // A7
  OP_DATA_I8 or ($8A shl 16) or OP_W,                          // A8
  OP_DATA_PRE66 or ($8A shl 16) or OP_W,                       // A9
  ($55 shl 16) or OP_W,                                        // AA
  ($57 shl 16) or OP_MNEMDIFF or OP_W,                         // AB
  ($3A shl 16) or OP_W,                                        // AC
  ($3C shl 16) or OP_MNEMDIFF or OP_W,                         // AD
  ($4F shl 16) or OP_W,                                        // AE
  ($51 shl 16) or OP_MNEMDIFF or OP_W,                         // AF
  OP_DATA_I8 or ($96 shl 16) or OP_RD,                         // B0
  OP_DATA_I8 or ($96 shl 16) or OP_RD,                         // B1
  OP_DATA_I8 or ($96 shl 16) or OP_RD,                         // B2
  OP_DATA_I8 or ($96 shl 16) or OP_RD,                         // B3
  OP_DATA_I8 or ($96 shl 16) or OP_RD,                         // B4
  OP_DATA_I8 or ($96 shl 16) or OP_RD,                         // B5
  OP_DATA_I8 or ($96 shl 16) or OP_RD,                         // B6
  OP_DATA_I8 or ($96 shl 16) or OP_RD,                         // B7
  OP_DATA_PRE66 or ($96 shl 16) or OP_RD,                      // B8
  OP_DATA_PRE66 or ($96 shl 16) or OP_RD,                      // B9
  OP_DATA_PRE66 or ($96 shl 16) or OP_RD,                      // BA
  OP_DATA_PRE66 or ($96 shl 16) or OP_RD,                      // BB
  OP_DATA_PRE66 or ($96 shl 16) or OP_RD,                      // BC
  OP_DATA_PRE66 or ($96 shl 16) or OP_RD,                      // BD
  OP_DATA_PRE66 or ($96 shl 16) or OP_RD,                      // BE
  OP_DATA_PRE66 or ($96 shl 16) or OP_RD,                      // BF
  OP_MODRM or OP_DATA_I8 or OP_MODRM_USED or OP_W,             // C0
  OP_MODRM or OP_DATA_I8 or OP_MODRM_USED or OP_W,             // C1
  OP_DATA_I16 or ($BA shl 16),                                 // C2
  ($4C shl 16),                                                // C3
  OP_MODRM or ($84 shl 16),                                    // C4
  OP_MODRM or ($83 shl 16),                                    // C5
  OP_MODRM or OP_DATA_I8 or OP_MODRM_USED or OP_W,             // C6
  OP_MODRM or OP_DATA_PRE66 or OP_MODRM_USED or OP_W,          // C7
  OP_DATA_I8 or OP_DATA_I16 or ($6E shl 16),                   // C8
  ($39 shl 16),                                                // C9
  OP_DATA_I16 or ($4D shl 16),                                 // CA
  ($4D shl 16),                                                // CB
  ($C2 shl 16),                                                // CC
  OP_DATA_I8 or ($C1 shl 16),                                  // CD
  ($34 shl 16),                                                // CE
  ($37 shl 16) or OP_MNEMDIFF,                                 // CF
  OP_MODRM or OP_MODRM_USED or OP_W or OP_ONE,                 // D0
  OP_MODRM or OP_MODRM_USED or OP_W or OP_ONE,                 // D1
  OP_MODRM or OP_MODRM_USED or OP_W or OP_ONE,                 // D2
  OP_MODRM or OP_MODRM_USED or OP_W or OP_ONE,                 // D3
  OP_DATA_I8 or ($02 shl 16),                                  // D4
  OP_DATA_I8 or ($01 shl 16),                                  // D5
  ($B7 shl 16),                                                // D6
  ($5A shl 16),                                                // D7
  OP_MODRM or OP_WORD or OP_MODRM_USED or OP_ONE,              // D8
  OP_MODRM or OP_WORD or OP_MODRM_USED or OP_ONE,              // D9
  OP_MODRM or OP_WORD or OP_MODRM_USED or OP_ONE,              // DA
  OP_MODRM or OP_WORD or OP_MODRM_USED or OP_ONE,              // DB
  OP_MODRM or OP_WORD or OP_MODRM_USED or OP_ONE,              // DC
  OP_MODRM or OP_WORD or OP_MODRM_USED or OP_ONE,              // DD
  OP_MODRM or OP_WORD or OP_MODRM_USED or OP_ONE,              // DE
  OP_MODRM or OP_WORD or OP_MODRM_USED or OP_ONE,              // DF
  OP_DATA_I8 or ($C5 shl 16),                                  // E0
  OP_DATA_I8 or ($C4 shl 16),                                  // E1
  OP_DATA_I8 or ($C3 shl 16),                                  // E2
  OP_DATA_I8 or ($CA shl 16),                                  // E3
  OP_DATA_I8 or ($75 shl 16) or OP_W,                          // E4
  OP_DATA_I8 or ($75 shl 16) or OP_W,                          // E5
  OP_DATA_I8 or ($76 shl 16) or OP_W,                          // E6
  OP_DATA_I8 or ($76 shl 16) or OP_W,                          // E7
  OP_DATA_PRE66 or ($9A shl 16),                               // E8
  OP_DATA_PRE66 or ($D5 shl 16),                               // E9
  OP_DATA_I16 or OP_DATA_I32 or ($D5 shl 16),                  // EA
  OP_DATA_I8 or ($D5 shl 16),                                  // EB
  ($75 shl 16) or OP_W,                                        // EC
  ($75 shl 16) or OP_W,                                        // ED
  ($76 shl 16) or OP_W,                                        // EE
  ($76 shl 16) or OP_W,                                        // EF
  OP_NONE,                                                     // F0
  ($DE shl 16),                                                // F1
  OP_NONE,                                                     // F2
  OP_NONE,                                                     // F3
  ($30 shl 16),                                                // F4
  ($0A shl 16),                                                // F5
  OP_MODRM or OP_MODRM_USED or OP_W or OP_ONE,                 // F6
  OP_MODRM or OP_MODRM_USED or OP_W or OP_ONE,                 // F7
  ($06 shl 16),                                                // F8
  ($52 shl 16),                                                // F9
  ($08 shl 16),                                                // FA
  ($54 shl 16),                                                // FB
  ($07 shl 16),                                                // FC
  ($53 shl 16),                                                // FD
  OP_MODRM or OP_MODRM_USED or OP_W or OP_ONE,                 // FE
  OP_MODRM or OP_MODRM_USED or OP_W or OP_ONE                  // FF
 );

 OpcodeFlagsExt: array [$00..$FF] of dword =
 (
  OP_MODRM or OP_MODRM_USED or OP_ONE,                         // 00
  OP_MODRM or OP_MODRM_USED or OP_ONE,                         // 01
  OP_MODRM or ($73 shl 16),                                    // 02
  OP_MODRM or ($89 shl 16),                                    // 03
  OP_NONE,                                                     // 04
  OP_NONE,                                                     // 05
  ($09 shl 16),                                                // 06
  OP_NONE,                                                     // 07
  ($35 shl 16),                                                // 08
  ($59 shl 16),                                                // 09
  OP_NONE,                                                     // 0A
  ($5F shl 16),                                                // 0B
  OP_NONE,                                                     // 0C
  OP_NONE,                                                     // 0D
  OP_NONE,                                                     // 0E
  OP_NONE,                                                     // 0F
  OP_MODRM or ($37 shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 10
  OP_MODRM or ($37 shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX or OP_REV,                          // 11
  OP_MODRM or ($32 shl 16) or OP_SSE or OP_MNEMEXT,            // 12
  OP_NONE,                                                     // 13
  OP_MODRM or ($48 shl 16) or OP_SSE or OP_MNEMEXT,            // 14
  OP_MODRM or ($47 shl 16) or OP_SSE or OP_MNEMEXT,            // 15
  OP_MODRM or ($34 shl 16) or OP_SSE or OP_MNEMEXT,            // 16
  OP_MODRM or ($35 shl 16) or OP_SSE or OP_MNEMEXT or OP_REV,  // 17
  OP_MODRM or OP_MODRM_USED or OP_ONE,                         // 18
  OP_NONE,                                                     // 19
  OP_NONE,                                                     // 1A
  OP_NONE,                                                     // 1B
  OP_NONE,                                                     // 1C
  OP_NONE,                                                     // 1D
  OP_NONE,                                                     // 1E
  OP_NONE,                                                     // 1F
  OP_MODRM or ($96 shl 16) or OP_EEE or OP_D,                  // 20
  OP_MODRM or ($96 shl 16) or OP_EEE or OP_D,                  // 21
  OP_MODRM or ($96 shl 16) or OP_EEE or OP_D,                  // 22
  OP_MODRM or ($96 shl 16) or OP_EEE or OP_D,                  // 23
  OP_MODRM or ($96 shl 16) or OP_EEE,                          // 24
  OP_NONE,                                                     // 25
  OP_MODRM or ($96 shl 16) or OP_EEE,                          // 26
  OP_NONE,                                                     // 27
  OP_MODRM or ($31 shl 16) or OP_SSE or OP_MNEMEXT,            // 28
  OP_MODRM or ($31 shl 16) or OP_SSE or OP_MNEMEXT or OP_REV,  // 29
  OP_MODRM or ($24 shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 2A
  OP_MODRM or ($4B shl 16) or OP_SSE or OP_MNEMEXT or OP_REV,  // 2B
  OP_MODRM or ($28 shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 2C
  OP_MODRM or ($26 shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 2D
  OP_MODRM or ($46 shl 16) or OP_SSE or OP_MNEMEXT,            // 2E
  OP_MODRM or ($23 shl 16) or OP_SSE or OP_MNEMEXT,            // 2F
  ($60 shl 16),                                                // 30
  ($5E shl 16),                                                // 31
  ($5C shl 16),                                                // 32
  ($5D shl 16),                                                // 33
  ($DF shl 16),                                                // 34
  ($E0 shl 16),                                                // 35
  OP_NONE,                                                     // 36
  OP_NONE,                                                     // 37
  OP_NONE,                                                     // 38
  OP_NONE,                                                     // 39
  OP_NONE,                                                     // 3A
  OP_NONE,                                                     // 3B
  OP_NONE,                                                     // 3C
  OP_NONE,                                                     // 3D
  OP_NONE,                                                     // 3E
  OP_NONE,                                                     // 3F
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 40
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 41
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 42
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 43
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 44
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 45
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 46
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 47
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 48
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 49
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 4A
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 4B
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 4C
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 4D
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 4E
  OP_MODRM or ($E9 shl 16) or OP_TTTn,                         // 4F
  OP_MODRM or ($36 shl 16) or OP_SSE or OP_MNEMEXT,            // 50
  OP_MODRM or ($41 shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 51
  OP_MODRM or ($3E shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 52
  OP_MODRM or ($3C shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 53
  OP_MODRM or ($1F shl 16) or OP_SSE or OP_MNEMEXT,            // 54
  OP_MODRM or ($20 shl 16) or OP_SSE or OP_MNEMEXT,            // 55
  OP_MODRM or ($3B shl 16) or OP_SSE or OP_MNEMEXT,            // 56
  OP_MODRM or ($49 shl 16) or OP_SSE or OP_MNEMEXT,            // 57
  OP_MODRM or ($1D shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 58
  OP_MODRM or ($39 shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 59
  OP_NONE,                                                     // 5A
  OP_NONE,                                                     // 5B
  OP_MODRM or ($44 shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 5C
  OP_MODRM or ($2F shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 5D
  OP_MODRM or ($2A shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 5E
  OP_MODRM or ($2D shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX,                                    // 5F
  OP_MODRM or ($15 shl 16) or OP_MMX or OP_MNEMEXT,            // 60
  OP_MODRM or ($16 shl 16) or OP_MMX or OP_MNEMEXT,            // 61
  OP_MODRM or ($17 shl 16) or OP_MMX or OP_MNEMEXT,            // 62
  OP_MODRM or ($ED shl 16) or OP_MMX,                          // 63
  OP_MODRM or ($FC shl 16) or OP_MMX,                          // 64
  OP_MODRM or ($FD shl 16) or OP_MMX,                          // 65
  OP_MODRM or ($FE shl 16) or OP_MMX,                          // 66
  OP_MODRM or ($EF shl 16) or OP_MMX,                          // 67
  OP_MODRM or ($12 shl 16) or OP_MMX or OP_MNEMEXT,            // 68
  OP_MODRM or ($13 shl 16) or OP_MMX or OP_MNEMEXT,            // 69
  OP_MODRM or ($14 shl 16) or OP_MMX or OP_MNEMEXT,            // 6A
  OP_MODRM or ($EE shl 16) or OP_MMX,                          // 6B
  OP_NONE,                                                     // 6C
  OP_NONE,                                                     // 6D
  OP_MODRM or ($19 shl 16) or OP_MMX or OP_MNEMEXT,            // 6E
  OP_MODRM or ($EC shl 16) or OP_MMX,                          // 6F
  OP_MODRM or OP_DATA_I8 or ($58 shl 16) or
  OP_MMX or OP_MNEMEXT or OP_THREE,                            // 70
  OP_MODRM or OP_DATA_I8 or OP_MODRM_USED or OP_MMX,           // 71
  OP_MODRM or OP_DATA_I8 or OP_MODRM_USED or OP_MMX,           // 72
  OP_MODRM or OP_DATA_I8 or OP_MODRM_USED or OP_MMX,           // 73
  OP_MODRM or ($F9 shl 16) or OP_MMX,                          // 74
  OP_MODRM or ($FA shl 16) or OP_MMX,                          // 75
  OP_MODRM or ($FB shl 16) or OP_MMX,                          // 76
  ($EA shl 16),                                                // 77
  OP_NONE,                                                     // 78
  OP_NONE,                                                     // 79
  OP_NONE,                                                     // 7A
  OP_NONE,                                                     // 7B
  OP_NONE,                                                     // 7C
  OP_NONE,                                                     // 7D
  OP_MODRM or ($19 shl 16) or OP_MMX or OP_MNEMEXT or OP_REV,  // 7E
  OP_MODRM or ($EC shl 16) or OP_MMX or OP_REV,                // 7F
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 80
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 81
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 82
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 83
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 84
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 85
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 86
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 87
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 88
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 89
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 8A
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 8B
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 8C
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 8D
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 8E
  OP_DATA_PRE66 or OP_TTTn or ($D6 shl 16),                    // 8F
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 90
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 91
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 92
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 93
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 94
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 95
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 96
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 97
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 98
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 99
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 9A
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 9B
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 9C
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 9D
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 9E
  OP_MODRM or OP_TTTn or ($D7 shl 16) or OP_ONE or OP_BYTE,    // 9F
  ($D8 shl 16) or OP_SREG3,                                    // A0
  ($D9 shl 16) or OP_SREG3,                                    // A1
  ($5B shl 16),                                                // A2
  OP_MODRM or ($68 shl 16) or OP_REV,                          // A3
  OP_MODRM or OP_DATA_I8 or ($97 shl 16) or OP_THREE or OP_REV,// A4
  OP_MODRM or ($97 shl 16) or OP_REV,                          // A5
  OP_NONE,                                                     // A6
  OP_NONE,                                                     // A7
  ($D8 shl 16) or OP_SREG3,                                    // A8
  ($D9 shl 16) or OP_SREG3,                                    // A9
  ($EB shl 16),                                                // AA
  OP_MODRM or ($6B shl 16) or OP_REV,                          // AB
  OP_MODRM or OP_DATA_I8 or ($98 shl 16) or OP_THREE or OP_REV,// AC
  OP_MODRM or ($98 shl 16) or OP_REV,                          // AD
  OP_MODRM or OP_MODRM_USED or OP_ONE,                         // AE
  OP_MODRM or ($88 shl 16),                                    // AF
  OP_MODRM or ($6D shl 16) or OP_W or OP_REV,                  // B0
  OP_MODRM or ($6D shl 16) or OP_W or OP_REV,                  // B1
  OP_MODRM or ($85 shl 16),                                    // B2
  OP_MODRM or ($6A shl 16) or OP_REV,                          // B3
  OP_MODRM or ($87 shl 16),                                    // B4
  OP_MODRM or ($86 shl 16),                                    // B5
  OP_MODRM or ($94 shl 16),                                    // B6
  OP_MODRM or ($94 shl 16),                                    // B7
  OP_NONE,                                                     // B8
  OP_NONE,                                                     // B9
  OP_MODRM or OP_DATA_I8 or OP_MODRM_USED,                     // BA
  OP_MODRM or ($69 shl 16) or OP_REV,                          // BB
  OP_MODRM or ($66 shl 16),                                    // BC
  OP_MODRM or ($67 shl 16),                                    // BD
  OP_MODRM or ($93 shl 16),                                    // BE
  OP_MODRM or ($93 shl 16),                                    // BF
  OP_MODRM or ($92 shl 16) or OP_W or OP_REV,                  // C0
  OP_MODRM or ($92 shl 16) or OP_W or OP_REV,                  // C1
  OP_MODRM or ($21 shl 16) or OP_SSE or
  OP_MNEMEXT or OP_SSE_PFX or OP_DATA_I8 or OP_THREE,          // C2
  OP_NONE,                                                     // C3
  OP_MODRM or OP_DATA_I8 or ($50 shl 16) or
  OP_MMX or OP_MNEMEXT or OP_THREE,                            // C4
  OP_MODRM or OP_DATA_I8 or ($4F shl 16) or
  OP_MMX or OP_MNEMEXT or OP_THREE,                            // C5
  OP_MODRM or ($40 shl 16) or OP_SSE or
  OP_MNEMEXT or OP_DATA_I8 or OP_THREE,                        // C6
  OP_MODRM or OP_MODRM_USED or OP_MMX or OP_ONE,               // C7
  ($99 shl 16) or OP_RD,                                       // C8
  ($99 shl 16) or OP_RD,                                       // C9
  ($99 shl 16) or OP_RD,                                       // CA
  ($99 shl 16) or OP_RD,                                       // CB
  ($99 shl 16) or OP_RD,                                       // CC
  ($99 shl 16) or OP_RD,                                       // CD
  ($99 shl 16) or OP_RD,                                       // CE
  ($99 shl 16) or OP_RD,                                       // CF
  OP_NONE,                                                     // D0
  OP_MODRM or ($08 shl 16) or OP_MMX or OP_MNEMEXT,            // D1
  OP_MODRM or ($09 shl 16) or OP_MMX or OP_MNEMEXT,            // D2
  OP_MODRM or ($0A shl 16) or OP_MMX or OP_MNEMEXT,            // D3
  OP_NONE,                                                     // D4
  OP_MODRM or ($01 shl 16) or OP_MMX or OP_MNEMEXT,            // D5
  OP_NONE,                                                     // D6
  OP_MODRM or ($55 shl 16) or OP_MMX or OP_MNEMEXT,            // D7
  OP_MODRM or ($10 shl 16) or OP_MMX or OP_MNEMEXT,            // D8
  OP_MODRM or ($11 shl 16) or OP_MMX or OP_MNEMEXT,            // D9
  OP_MODRM or ($54 shl 16) or OP_MMX or OP_MNEMEXT,            // DA
  OP_MODRM or ($F7 shl 16) or OP_MMX,                          // DB
  OP_MODRM or ($F5 shl 16) or OP_MMX,                          // DC
  OP_MODRM or ($F6 shl 16) or OP_MMX,                          // DD
  OP_MODRM or ($52 shl 16) or OP_MMX or OP_MNEMEXT,            // DE
  OP_MODRM or ($F8 shl 16) or OP_MMX,                          // DF
  OP_MODRM or ($4D shl 16) or OP_MMX or OP_MNEMEXT,            // E0
  OP_MODRM or ($06 shl 16) or OP_MMX or OP_MNEMEXT,            // E1
  OP_MODRM or ($07 shl 16) or OP_MMX or OP_MNEMEXT,            // E2
  OP_MODRM or ($4E shl 16) or OP_MMX or OP_MNEMEXT,            // E3
  OP_MODRM or ($56 shl 16) or OP_MMX or OP_MNEMEXT,            // E4
  OP_MODRM or ($00 shl 16) or OP_MMX or OP_MNEMEXT,            // E5
  OP_NONE,                                                     // E6
  OP_MODRM or ($4C shl 16) or OP_MMX or OP_MNEMEXT or OP_REV,  // E7
  OP_MODRM or ($0E shl 16) or OP_MMX or OP_MNEMEXT,            // E8
  OP_MODRM or ($0F shl 16) or OP_MMX or OP_MNEMEXT,            // E9
  OP_MODRM or ($53 shl 16) or OP_MMX or OP_MNEMEXT,            // EA
  OP_MODRM or ($02 shl 16) or OP_MMX or OP_MNEMEXT,            // EB
  OP_MODRM or ($F3 shl 16) or OP_MMX,                          // EC
  OP_MODRM or ($F4 shl 16) or OP_MMX,                          // ED
  OP_MODRM or ($51 shl 16) or OP_MMX or OP_MNEMEXT,            // EE
  OP_MODRM or ($18 shl 16) or OP_MMX or OP_MNEMEXT,            // EF
  OP_NONE,                                                     // F0
  OP_MODRM or ($03 shl 16) or OP_MMX or OP_MNEMEXT,            // F1
  OP_MODRM or ($04 shl 16) or OP_MMX or OP_MNEMEXT,            // F2
  OP_MODRM or ($05 shl 16) or OP_MMX or OP_MNEMEXT,            // F3
  OP_NONE,                                                     // F4
  OP_MODRM or ($FF shl 16) or OP_MMX,                          // F5
  OP_MODRM or ($57 shl 16) or OP_MMX or OP_MNEMEXT,            // F6
  OP_MODRM or ($4A shl 16) or OP_MMX or OP_MNEMEXT,            // F7
  OP_MODRM or ($0B shl 16) or OP_MMX or OP_MNEMEXT,            // F8
  OP_MODRM or ($0C shl 16) or OP_MMX or OP_MNEMEXT,            // F9
  OP_MODRM or ($0D shl 16) or OP_MMX or OP_MNEMEXT,            // FA
  OP_NONE,                                                     // FB
  OP_MODRM or ($F0 shl 16) or OP_MMX,                          // FC
  OP_MODRM or ($F1 shl 16) or OP_MMX,                          // FD
  OP_MODRM or ($F2 shl 16) or OP_MMX,                          // FE
  OP_NONE                                                      // FF
 );

 {
   Modrm Used instructions Extended Flags:
   Bits 8..15 - opcode, 16..18 - REG, 0..7 - flags
 }
const
 ModrmUsedExtendedLen = 1;
  
 ModrmUsedExtendedFlags: array [0..1] of dword =
 (
  ($F6 shl 8) or ($0 shl 18) or OP_DATA_I8,
  ($F7 shl 8) or ($0 shl 18) or OP_DATA_I32
 );

 {
   Bits 0..7 - mnemonic ordinal, 8..15 - opcode.
 }
 MnemDiffTableLen = 11;
 MnemDiffTable: array [0..11] of word =
 (
   ($60 shl 8) or $48,
   ($61 shl 8) or $44,
   ($98 shl 8) or $05,
   ($99 shl 8) or $0E,
   ($A5 shl 8) or $3E,
   ($A7 shl 8) or $0C,
   ($AB shl 8) or $56,
   ($AD shl 8) or $3B,
   ($AF shl 8) or $50,
   ($CF shl 8) or $36,
   ($6F shl 8) or $42,
   ($6D shl 8) or $32
 );


 {
 word opcodes table format:
 Bits 0..7 - Opcode two byte
 Bits 8..15 - Opcode ordinal (or_con = idx shl 8)
}
const
 OpcodeWordD9Len = $2B;
 OpcodeWordD9: array[$00..$2B] of word =  //for D9 first byte
 (
  $F0 or ($12 shl 8),
  $E1 or ($13 shl 8),
  $E0 or ($14 shl 8),
  $FF or ($16 shl 8),
  $F6 or ($17 shl 8),
  $F7 or ($18 shl 8),
  $E8 or ($1A shl 8),
  $E9 or ($1B shl 8),
  $EA or ($1C shl 8),
  $EB or ($1D shl 8),
  $EC or ($1E shl 8),
  $ED or ($1F shl 8),
  $EE or ($20 shl 8),
  $D0 or ($21 shl 8),
  $F3 or ($22 shl 8),
  $F8 or ($23 shl 8),
  $F5 or ($24 shl 8),
  $F2 or ($25 shl 8),
  $FC or ($26 shl 8),
  $FD or ($27 shl 8),
  $FE or ($28 shl 8),
  $FB or ($29 shl 8),
  $FA or ($2A shl 8),
  $E4 or ($2B shl 8),
  $E5 or ($2C shl 8),
  $F4 or ($2D shl 8),
  $F1 or ($2E shl 8),
  $F9 or ($2F shl 8),
  $C8 or ($AD shl 8),
  $C9 or ($AD shl 8),
  $CA or ($AD shl 8),
  $CB or ($AD shl 8),
  $CC or ($AD shl 8),
  $CD or ($AD shl 8),
  $CE or ($AD shl 8),
  $CF or ($AD shl 8),
  $C0 or ($B1 shl 8),
  $C1 or ($B1 shl 8),
  $C2 or ($B1 shl 8),
  $C3 or ($B1 shl 8),
  $C4 or ($B1 shl 8),
  $C5 or ($B1 shl 8),
  $C6 or ($B1 shl 8),
  $C7 or ($B1 shl 8)
 );

 OpcodeWordDBLen = 33;
 OpcodeWordDB: array[00..33] of word =  //for DB first byte
 (
  $E2 or ($15 shl 8),
  $E3 or ($19 shl 8),
  $C0 or ($E5 shl 8),
  $C1 or ($E5 shl 8),
  $C2 or ($E5 shl 8),
  $C3 or ($E5 shl 8),
  $C4 or ($E5 shl 8),
  $C5 or ($E5 shl 8),
  $C6 or ($E5 shl 8),
  $C7 or ($E5 shl 8),
  $C8 or ($E6 shl 8),
  $C9 or ($E6 shl 8),
  $CA or ($E6 shl 8),
  $CB or ($E6 shl 8),
  $CC or ($E6 shl 8),
  $CD or ($E6 shl 8),
  $CE or ($E6 shl 8),
  $CF or ($E6 shl 8),
  $D0 or ($E7 shl 8),
  $D1 or ($E7 shl 8),
  $D2 or ($E7 shl 8),
  $D3 or ($E7 shl 8),
  $D4 or ($E7 shl 8),
  $D5 or ($E7 shl 8),
  $D6 or ($E7 shl 8),
  $D7 or ($E7 shl 8),
  $D8 or ($E8 shl 8),
  $D9 or ($E8 shl 8),
  $DA or ($E8 shl 8),
  $DB or ($E8 shl 8),
  $DC or ($E8 shl 8),
  $DD or ($E8 shl 8),
  $DE or ($E8 shl 8),
  $DF or ($E8 shl 8)
 );

 OpcodeWordDELen = $30;
 OpcodeWordDE: array[$00..$30] of word =  //for DE first byte
 (
  $C0 or ($78 shl 8),
  $C1 or ($78 shl 8),
  $C2 or ($78 shl 8),
  $C3 or ($78 shl 8),
  $C4 or ($78 shl 8),
  $C5 or ($78 shl 8),
  $C6 or ($78 shl 8),
  $C7 or ($78 shl 8),
  $C8 or ($7A shl 8),
  $C9 or ($7A shl 8),
  $CA or ($7A shl 8),
  $CB or ($7A shl 8),
  $CC or ($7A shl 8),
  $CD or ($7A shl 8),
  $CE or ($7A shl 8),
  $CF or ($7A shl 8),
  $F8 or ($7C shl 8),
  $F9 or ($7C shl 8),
  $FA or ($7C shl 8),
  $FB or ($7C shl 8),
  $FC or ($7C shl 8),
  $FD or ($7C shl 8),
  $FE or ($7C shl 8),
  $FF or ($7C shl 8),
  $F0 or ($7E shl 8),
  $F1 or ($7E shl 8),
  $F2 or ($7E shl 8),
  $F3 or ($7E shl 8),
  $F4 or ($7E shl 8),
  $F5 or ($7E shl 8),
  $F6 or ($7E shl 8),
  $F7 or ($7E shl 8),
  $E8 or ($80 shl 8),
  $E9 or ($80 shl 8),
  $EA or ($80 shl 8),
  $EB or ($80 shl 8),
  $EC or ($80 shl 8),
  $ED or ($80 shl 8),
  $EE or ($80 shl 8),
  $EF or ($80 shl 8),
  $E0 or ($82 shl 8),
  $E1 or ($82 shl 8),
  $E2 or ($82 shl 8),
  $E3 or ($82 shl 8),
  $E4 or ($82 shl 8),
  $E5 or ($82 shl 8),
  $E6 or ($82 shl 8),
  $E7 or ($82 shl 8),
  $D9 or ($A4 shl 8)
 );

 OpcodeWordDDLen = 39;
 OpcodeWordDD: array[00..39] of word =  //for DD first byte
 (
  $E0 or ($A5 shl 8),
  $E1 or ($A5 shl 8),
  $E2 or ($A5 shl 8),
  $E3 or ($A5 shl 8),
  $E4 or ($A5 shl 8),
  $E5 or ($A5 shl 8),
  $E6 or ($A5 shl 8),
  $E7 or ($A5 shl 8),
  $E8 or ($A6 shl 8),
  $E9 or ($A6 shl 8),
  $EA or ($A6 shl 8),
  $EB or ($A6 shl 8),
  $EC or ($A6 shl 8),
  $ED or ($A6 shl 8),
  $EE or ($A6 shl 8),
  $EF or ($A6 shl 8),
  $C0 or ($AC shl 8),
  $C1 or ($AC shl 8),
  $C2 or ($AC shl 8),
  $C3 or ($AC shl 8),
  $C4 or ($AC shl 8),
  $C5 or ($AC shl 8),
  $C6 or ($AC shl 8),
  $C7 or ($AC shl 8),
  $D0 or ($B2 shl 8),
  $D1 or ($B2 shl 8),
  $D2 or ($B2 shl 8),
  $D3 or ($B2 shl 8),
  $D4 or ($B2 shl 8),
  $D5 or ($B2 shl 8),
  $D6 or ($B2 shl 8),
  $D7 or ($B2 shl 8),
  $D8 or ($B3 shl 8),
  $D9 or ($B3 shl 8),
  $DA or ($B3 shl 8),
  $DB or ($B3 shl 8),
  $DC or ($B3 shl 8),
  $DD or ($B3 shl 8),
  $DE or ($B3 shl 8),
  $DF or ($B3 shl 8)
 );

 OpcodeWordDALen = 32;
 OpcodeWordDA: array[0..32] of word =  //for DA first byte
 (
  $E9 or ($A7 shl 8),
  $C0 or ($E1 shl 8),
  $C1 or ($E1 shl 8),
  $C2 or ($E1 shl 8),
  $C3 or ($E1 shl 8),
  $C4 or ($E1 shl 8),
  $C5 or ($E1 shl 8),
  $C6 or ($E1 shl 8),
  $C7 or ($E1 shl 8),
  $C8 or ($E2 shl 8),
  $C9 or ($E2 shl 8),
  $CA or ($E2 shl 8),
  $CB or ($E2 shl 8),
  $CC or ($E2 shl 8),
  $CD or ($E2 shl 8),
  $CE or ($E2 shl 8),
  $CF or ($E2 shl 8),
  $D0 or ($E3 shl 8),
  $D1 or ($E3 shl 8),
  $D2 or ($E3 shl 8),
  $D3 or ($E3 shl 8),
  $D4 or ($E3 shl 8),
  $D5 or ($E3 shl 8),
  $D6 or ($E3 shl 8),
  $D7 or ($E3 shl 8),
  $D8 or ($E4 shl 8),
  $D9 or ($E4 shl 8),
  $DA or ($E4 shl 8),
  $DB or ($E4 shl 8),
  $DC or ($E4 shl 8),
  $DD or ($E4 shl 8),
  $DE or ($E4 shl 8),
  $DF or ($E4 shl 8)
 );

 OpcodeWordD8Len = 63;
 OpcodeWordD8: array[0..63] of word =  //for D8 first byte
 (
  $D0 or ($A2 shl 8),
  $D1 or ($A2 shl 8),
  $D2 or ($A2 shl 8),
  $D3 or ($A2 shl 8),
  $D4 or ($A2 shl 8),
  $D5 or ($A2 shl 8),
  $D6 or ($A2 shl 8),
  $D7 or ($A2 shl 8),
  $D8 or ($A3 shl 8),
  $D9 or ($A3 shl 8),
  $DA or ($A3 shl 8),
  $DB or ($A3 shl 8),
  $DC or ($A3 shl 8),
  $DD or ($A3 shl 8),
  $DE or ($A3 shl 8),
  $DF or ($A3 shl 8),
  $F0 or ($7B shl 8),
  $F1 or ($7B shl 8),
  $F2 or ($7B shl 8),
  $F3 or ($7B shl 8),
  $F4 or ($7B shl 8),
  $F5 or ($7B shl 8),
  $F6 or ($7B shl 8),
  $F7 or ($7B shl 8),
  $F8 or ($7D shl 8),
  $F9 or ($7D shl 8),
  $FA or ($7D shl 8),
  $FB or ($7D shl 8),
  $FC or ($7D shl 8),
  $FD or ($7D shl 8),
  $FE or ($7D shl 8),
  $FF or ($7D shl 8),
  $E0 or ($7F shl 8),
  $E1 or ($7F shl 8),
  $E2 or ($7F shl 8),
  $E3 or ($7F shl 8),
  $E4 or ($7F shl 8),
  $E5 or ($7F shl 8),
  $E6 or ($7F shl 8),
  $E7 or ($7F shl 8),
  $E8 or ($81 shl 8),
  $E9 or ($81 shl 8),
  $EA or ($81 shl 8),
  $EB or ($81 shl 8),
  $EC or ($81 shl 8),
  $ED or ($81 shl 8),
  $EE or ($81 shl 8),
  $EF or ($81 shl 8),
  $C0 or ($77 shl 8),
  $C1 or ($77 shl 8),
  $C2 or ($77 shl 8),
  $C3 or ($77 shl 8),
  $C4 or ($77 shl 8),
  $C5 or ($77 shl 8),
  $C6 or ($77 shl 8),
  $C7 or ($77 shl 8),
  $C8 or ($79 shl 8),
  $C9 or ($79 shl 8),
  $CA or ($79 shl 8),
  $CB or ($79 shl 8),
  $CC or ($79 shl 8),
  $CD or ($79 shl 8),
  $CE or ($79 shl 8),
  $CF or ($79 shl 8)
 );

 OpcodeWordDCLen = 62;
 OpcodeWordDC: array[0..62] of word =  //for DC first byte
 (
  $C0 or ($77 shl 8),
  $C1 or ($77 shl 8),
  $C2 or ($77 shl 8),
  $C3 or ($77 shl 8),
  $C4 or ($77 shl 8),
  $C5 or ($77 shl 8),
  $C6 or ($77 shl 8),
  $C7 or ($77 shl 8),
  $F8 or ($7B shl 8),
  $F9 or ($7B shl 8),
  $FA or ($7B shl 8),
  $FB or ($7B shl 8),
  $FC or ($7B shl 8),
  $FD or ($7B shl 8),
  $FE or ($7B shl 8),
  $FF or ($7B shl 8),
  $F0 or ($7D shl 8),
  $F1 or ($7D shl 8),
  $F2 or ($7D shl 8),
  $F3 or ($7D shl 8),
  $F4 or ($7D shl 8),
  $F5 or ($7D shl 8),
  $F6 or ($7D shl 8),
  $F7 or ($7D shl 8),
  $C8 or ($79 shl 8),
  $C9 or ($79 shl 8),
  $CA or ($79 shl 8),
  $CB or ($79 shl 8),
  $CC or ($79 shl 8),
  $CD or ($79 shl 8),
  $CE or ($79 shl 8),
  $CF or ($79 shl 8),
  $E8 or ($7F shl 8),
  $E9 or ($7F shl 8),
  $EA or ($7F shl 8),
  $EB or ($7F shl 8),
  $EC or ($7F shl 8),
  $ED or ($7F shl 8),
  $EF or ($7F shl 8),
  $E0 or ($81 shl 8),
  $E1 or ($81 shl 8),
  $E2 or ($81 shl 8),
  $E3 or ($81 shl 8),
  $E4 or ($81 shl 8),
  $E5 or ($81 shl 8),
  $E6 or ($81 shl 8),
  $E7 or ($81 shl 8),
  $D0 or ($A2 shl 8),
  $D1 or ($A2 shl 8),
  $D2 or ($A2 shl 8),
  $D3 or ($A2 shl 8),
  $D4 or ($A2 shl 8),
  $D5 or ($A2 shl 8),
  $D6 or ($A2 shl 8),
  $D7 or ($A2 shl 8),
  $D8 or ($A3 shl 8),
  $D9 or ($A3 shl 8),
  $DA or ($A3 shl 8),
  $DB or ($A3 shl 8),
  $DC or ($A3 shl 8),
  $DD or ($A3 shl 8),
  $DE or ($A3 shl 8),
  $DF or ($A3 shl 8)
 );

 ModrmUsedMnems1: array[0..7] of byte =   //for codes 80h, 81h, 83h
 (
   $62, // add
   $6F, // or
   $61, // adc
   $70, // sbb
   $63, // and
   $71, // sub
   $72, // xor
   $6C  // cmp
 );

 ModrmUsedMnems2: array[0..7] of byte =   //for codes D8, DC
 (
   $77, // fadd
   $79, // fmul
   $A2, // fcom
   $A3, // fcomp
   $7F, // fsub
   $81, // fsubr
   $7B, // fdiv
   $7D  // fdivr  
 );

 ModrmUsedMnems3: array[0..7] of byte =   //for codes DA, DE
 (
   $9F, // fiadd
   $BD, // fimul
   $A8, // ficom
   $A9, // ficomp
   $BB, // fisub
   $BC, // fisubr
   $AA, // fidiv
   $AB  // fidivr
 );

 ModrmUsedMnems4: array[0..7] of byte =   //for codes F6, F7
 (
   $8A, // test
   $DA, // invalid
   $C0, // not
   $BF, // neg
   $BE, // mul
   $88, // imul
   $9D, // div
   $9E  // idiv
 );

 ModrmUsedMnems5: array[0..7] of byte =   //for codes D0,D1,D2,D3,C0,C1
 (
   $8D, // rol
   $8E, // ror
   $8B, // rcl
   $8C, // rcr
   $90, // shl
   $91, // shr
   $DA, // invalid
   $8F  // sar
 );

 ModrmUsedMnems6: array[0..7] of byte =   //for codes C6, C7
 (
   $96, // mov
   $DA, // invalid
   $DA, // invalid
   $DA, // invalid
   $DA, // invalid
   $DA, // invalid
   $DA, // invalid
   $DA  // invalid  
 );

 ModrmUsedMnems7: array[0..7] of byte =   //for code FF, FE
 (
   $9C, // inc
   $9B, // dec
   $9A, // call
   $9A, // call
   $D5, // jmp
   $D5, // jmp
   $D8, // push  
   $DA  // invalid
 );

 ModrmUsedMnems8: array[0..7] of byte =   //for codes DF
 (
   $AE, // fild
   $DA, // invalid
   $AF, // fist
   $B0, // fistp
   $A0, // fbld
   $AE, // fild
   $A1, // fbstp
   $B0  // fistp    
 );

 ModrmUsedMnems9: array[0..7] of byte =   //for codes  DB
 (
   $AE, // fild
   $DA, // invalid
   $AF, // fist
   $B0, // fistp
   $DA, // invalid
   $B1, // fld
   $DA, // invalid
   $B3  // fstp
 );

 ModrmUsedMnems10: array[0..7] of byte =   //for codes  D9
 (
   $B1, // fld      
   $DA, // invalid
   $B2, // fst
   $B3, // fstp
   $B6, // fldenv
   $B4, // fldcw
   $DB, // fnstenv
   $DC  // fnstcw
 );
 
 ModrmUsedMnems11: array[0..7] of byte =   //for codes  DD
 (
   $B1, // fld
   $DA, // invalid
   $B2, // fst
   $B3, // fstp
   $B9, // frstor
   $DA, // invalid
   $B8, // fsave
   $DD  // fnstsw
 );

 ModrmUsedMnems12: array[0..7] of byte =   //for codes  8F
 (
   $D9, // pop
   $DA, // invalid
   $DA, // invalid
   $DA, // invalid
   $DA, // invalid
   $DA, // invalid
   $DA, // invalid
   $DA  // invalid
 );

 ModrmUsedMnems13: array[0..7] of byte =   //for extended code BA
 (
   $DA, // invalid
   $DA, // invalid
   $DA, // invalid
   $DA, // invalid
   $68, // bt
   $6B, // bts
   $6A, // btr
   $69  // btc     
 );

 ModrmUsedMnems14: array[0..7] of byte =   //for extended code 00
 (
   $D1, // sldt
   $C7, // str
   $CD, // lldt
   $C6, // ltr
   $D3, // verr
   $D4, // verw
   $DA, // invalid
   $DA  // invalid
 );

 ModrmUsedMnems15: array[0..7] of byte =   //for extended code 01
 (
   $CF, // sgdt
   $D0, // sidt
   $CB, // lgdt
   $CC, // lidt
   $D2, // smsw
   $DA, // invalid
   $CE, // lmsw
   $C8  // invlpg  
 );

 MmxModrmUsedMnems1: array[0..7] of word =   //for extended code 71
 (
   $DA,  // invalid
   $DA,  // invalid
   $108, // PSRLW
   $DA,  // invalid
   $106, // PSRAW
   $DA,  // invalid
   $103, // PSLLW
   $DA   // invalid
 );

 MmxModrmUsedMnems2: array[0..7] of word =   //for extended code 72
 (
   $DA,  // invalid
   $DA,  // invalid
   $109, // PSRLD
   $DA,  // invalid
   $107, // PSRAD
   $DA,  // invalid
   $104, // PSLLD
   $DA   // invalid
 );

 MmxModrmUsedMnems3: array[0..7] of word =   //for extended code 73 
 (
   $DA,  // invalid
   $DA,  // invalid
   $10A, // PSRLQ
   $DA,  // invalid
   $DA,  // invalid
   $DA,  // invalid
   $105, // PSLLQ
   $DA   // invalid
 );

 MmxModrmUsedMnems4: array[0..7] of word =   //for extended code C7
 (
   $DA,   // invalid
   $11A,  // cmpxchg8b
   $DA,   // invalid
   $DA,   // invalid
   $DA,   // invalid
   $DA,   // invalid
   $DA,   // invalid
   $DA    // invalid
 );

 MmxModrmUsedMnems5: array[0..7] of word = //for extended code AE
 (
   $11B,  // fxrstor
   $11C,  // fxsave
   $12C,  // ldmxcsr
   $143,  // stmxcsr
   $DA,   // invalid
   $DA,   // invalid
   $DA,   // invalid
   $15D   // sfence
 );

 MmxModrmUsedMnems6: array[0..7] of word = //for extended code 18
 (
   $15C,  // prefetchnta
   $159,  // prefetcht0
   $15A,  // prefetcht1
   $15B,  // prefetcht2
   $DA,   // invalid
   $DA,   // invalid
   $DA,   // invalid
   $DA    // invalid
 );


 {
Base opcodes special flags
Bit: 7 6 5 4 3 2 1 0
            L OP_USEAL - ocode use AL register
           L-- OP_IMMREV - revers imm and param
          L---- OP_PARAMDX - two parametr - DX
         L------ OP_USECL - ocode use CL register
        L-------- OP_REVERS - reversed params
       L---------- OP_USE1 - param 1 used
      L------------ 
     L-------------- 
}
 OP_USEAL    = $01 shl 8;
 OP_IMMREV   = $02 shl 8;
 OP_PARAMDX  = $04 shl 8;
 OP_USECL    = $08 shl 8;
 OP_REVERS   = $10 shl 8;
 OP_USE1     = $20 shl 8;

 OpcodeSpecFlagsLen = 40;
 OpcodeSpecFlags: array[00..40] of word =
 (
  ($14) or OP_USEAL,
  ($15) or OP_USEAL,
  ($04) or OP_USEAL,
  ($05) or OP_USEAL,
  ($24) or OP_USEAL,
  ($25) or OP_USEAL,
  ($3C) or OP_USEAL,
  ($3D) or OP_USEAL,
  ($E4) or OP_USEAL,
  ($E5) or OP_USEAL,
  ($EC) or OP_USEAL or OP_PARAMDX,
  ($ED) or OP_USEAL or OP_PARAMDX,
  ($A0) or OP_USEAL,
  ($A1) or OP_USEAL,
  ($A2) or OP_USEAL or OP_REVERS,
  ($A3) or OP_USEAL or OP_REVERS,
  ($EE) or OP_USEAL or OP_PARAMDX or OP_REVERS,
  ($EF) or OP_USEAL or OP_PARAMDX or OP_REVERS,
  ($D2) or OP_USECL,
  ($D3) or OP_USECL,
  ($1C) or OP_USEAL,
  ($1D) or OP_USEAL,
  ($A8) or OP_USEAL,
  ($A9) or OP_USEAL,
  ($91) or OP_USEAL,
  ($92) or OP_USEAL,
  ($93) or OP_USEAL,
  ($94) or OP_USEAL,
  ($95) or OP_USEAL,
  ($96) or OP_USEAL,
  ($97) or OP_USEAL,
  ($34) or OP_USEAL,
  ($35) or OP_USEAL,
  ($E6) or OP_USEAL or OP_IMMREV,
  ($E7) or OP_USEAL or OP_IMMREV,
  ($D0) or OP_USE1,
  ($D1) or OP_USE1,
  ($0C) or OP_USEAL,
  ($0D) or OP_USEAL,
  ($2D) or OP_USEAL,
  ($2C) or OP_USEAL
 );

 {
Word Opcodes Flags: (high byte)
Bit: 7 6 5 4 3 2 1 0
            L OP_REGUSED - instruction opcode used ST(i) registers, if it bit set on non FPU instruction, then not revers use
           L-- OP_REVERSED - ST(0) ir right part in opcode 
          L---- OP_TWOPARAM - instruction has two parametrs
         L------ 
        L--------
       L----------
      L------------
     L--------------
Bits 0..7 - full instruction opcode (word) (opcode shl 16)


}
 OP_REGUSED  = $01 shl 16;
 OP_REVERSED = $02 shl 16;
 OP_TWOPARAM = $04 shl 16;

 OpcodeFpuFlagsLen = 38;
 OpcodeFpuFlags: array[00..38] of dword =
 (
  ($D8C0) or OP_REGUSED or OP_TWOPARAM,
  ($DCC0) or OP_REGUSED or OP_REVERSED,
  ($DEC0) or OP_REGUSED or OP_REVERSED,
  ($DAC0) or OP_REGUSED or OP_TWOPARAM,
  ($DAC8) or OP_REGUSED or OP_TWOPARAM,
  ($DAD0) or OP_REGUSED or OP_TWOPARAM,
  ($DAD8) or OP_REGUSED or OP_TWOPARAM,
  ($DBC0) or OP_REGUSED or OP_TWOPARAM,
  ($DBC8) or OP_REGUSED or OP_TWOPARAM,
  ($DBD0) or OP_REGUSED or OP_TWOPARAM,
  ($DBD8) or OP_REGUSED or OP_TWOPARAM,
  ($D8D0) or OP_REGUSED,
  ($DEC8) or OP_REGUSED or OP_REVERSED,
  ($D8D8) or OP_REGUSED,
  ($DBF0) or OP_REGUSED or OP_TWOPARAM,
  ($DFF0) or OP_REGUSED or OP_TWOPARAM,
  ($DBE8) or OP_REGUSED or OP_TWOPARAM,
  ($DFE8) or OP_REGUSED or OP_TWOPARAM,
  ($D8F0) or OP_REGUSED or OP_TWOPARAM,
  ($DCF8) or OP_REGUSED or OP_REVERSED,
  ($DEF8) or OP_REGUSED or OP_REVERSED,
  ($D8F8) or OP_REGUSED or OP_TWOPARAM,
  ($DCF0) or OP_REGUSED or OP_REVERSED,
  ($DEF0) or OP_REGUSED or OP_REVERSED,
  ($DDC0) or OP_REGUSED,
  ($D9C0) or OP_REGUSED,
  ($D8C8) or OP_REGUSED or OP_TWOPARAM,
  ($DCC8) or OP_REGUSED or OP_REVERSED,
  ($DDD0) or OP_REGUSED,
  ($DDD8) or OP_REGUSED,
  ($D8E0) or OP_REGUSED or OP_TWOPARAM,
  ($DCE8) or OP_REGUSED or OP_REVERSED,
  ($DEE8) or OP_REGUSED or OP_REVERSED,
  ($D8E8) or OP_REGUSED or OP_TWOPARAM,
  ($DCE0) or OP_REGUSED or OP_REVERSED,
  ($DEE0) or OP_REGUSED or OP_REVERSED,
  ($DDE0) or OP_REGUSED,
  ($DDE8) or OP_REGUSED,
  ($D9C8) or OP_REGUSED
 );

 
{
  FPU commands memory format table.
  Bits 0..7  - Opcode
  Bits 8..10  - Ptr type
  Bits 11-13 - REG value
}                        
const
 FpuMemFmtLen = 49;
 FpuMemFmt: array[0..49] of word =
 (
  $D8 or (0 shl 11) or F_PTR_REAL4,
  $D8 or (1 shl 11) or F_PTR_REAL4,
  $D8 or (2 shl 11) or F_PTR_REAL4,
  $D8 or (3 shl 11) or F_PTR_REAL4,
  $D8 or (4 shl 11) or F_PTR_REAL4,
  $D8 or (5 shl 11) or F_PTR_REAL4,
  $D8 or (6 shl 11) or F_PTR_REAL4,
  $D8 or (7 shl 11) or F_PTR_REAL4,
  $DC or (0 shl 11) or F_PTR_REAL8,
  $DC or (1 shl 11) or F_PTR_REAL8,
  $DC or (2 shl 11) or F_PTR_REAL8,
  $DC or (3 shl 11) or F_PTR_REAL8,
  $DC or (4 shl 11) or F_PTR_REAL8,
  $DC or (5 shl 11) or F_PTR_REAL8,
  $DC or (6 shl 11) or F_PTR_REAL8,
  $DC or (7 shl 11) or F_PTR_REAL8,
  $DA or (0 shl 11) or F_PTR_DWORD,
  $DA or (1 shl 11) or F_PTR_DWORD,
  $DA or (2 shl 11) or F_PTR_DWORD,
  $DA or (3 shl 11) or F_PTR_DWORD,
  $DA or (4 shl 11) or F_PTR_DWORD,
  $DA or (5 shl 11) or F_PTR_DWORD,
  $DA or (6 shl 11) or F_PTR_DWORD,
  $DA or (7 shl 11) or F_PTR_DWORD,
  $DE or (0 shl 11) or F_PTR_WORD,
  $DE or (1 shl 11) or F_PTR_WORD,
  $DE or (2 shl 11) or F_PTR_WORD,
  $DE or (3 shl 11) or F_PTR_WORD,
  $DE or (4 shl 11) or F_PTR_WORD,
  $DE or (5 shl 11) or F_PTR_WORD,
  $DE or (6 shl 11) or F_PTR_WORD,
  $DE or (7 shl 11) or F_PTR_WORD,
  $DF or (4 shl 11) or F_PTR_TBYTE,
  $DF or (6 shl 11) or F_PTR_TBYTE,
  $DF or (0 shl 11) or F_PTR_WORD,
  $DF or (5 shl 11) or F_PTR_QWORD,
  $DF or (2 shl 11) or F_PTR_WORD,
  $DF or (3 shl 11) or F_PTR_WORD,
  $DF or (7 shl 11) or F_PTR_QWORD,
  $DB or (0 shl 11) or F_PTR_DWORD,
  $DB or (2 shl 11) or F_PTR_DWORD,
  $DB or (3 shl 11) or F_PTR_DWORD,
  $DB or (5 shl 11) or F_PTR_REAL10,
  $DB or (7 shl 11) or F_PTR_REAL10,
  $D9 or (0 shl 11) or F_PTR_REAL4,
  $D9 or (2 shl 11) or F_PTR_REAL4,
  $D9 or (3 shl 11) or F_PTR_REAL4,
  $DD or (0 shl 11) or F_PTR_REAL8,
  $DD or (2 shl 11) or F_PTR_REAL8,
  $DD or (3 shl 11) or F_PTR_REAL8
 );

const
 RelInstrSize = 7;
 RelInstrTable: array [0..7] of byte =
 (
  $D5,  // jmp
  $D6,  // Jcc
  $9A,  // call
  $C9,  // jcxz
  $CA,  // jecxz
  $C3,  // loop
  $C4,  // loopz
  $C5   // loopnz
 );

const
 MnemArr: array[00..$15D] of string[12] = 
 (
  'aaa',         // 00
  'aad',         // 01
  'aam',         // 02
  'aas',         // 03
  'cwde',        // 04
  'cbw',         // 05
  'clc',         // 06
  'cld',         // 07
  'cli',         // 08
  'clts',        // 09
	'cmc',         // 0A
  'cmpsb',       // 0B
  'cmpsw',       // 0C
  'cmpsd',       // 0D
  'cwd',         // 0E
  'cdq',         // 0F
  'daa',         // 10
  'das',         // 11
  'f2xm1',       // 12
	'fabs',        // 13
  'fchs',        // 14
  'fclex',       // 15
  'fcos',        // 16
  'fdecstp',     // 17
  'fincstp',     // 18
  'finit',       // 19
  'fld1',        // 1A
	'fldl2t',      // 1B
  'fldl2e',      // 1C
  'fldpi',       // 1D
  'fldlg2',      // 1E
  'fldln2',      // 1F
  'fldz',        // 20
  'fnop',        // 21
	'fpatan',      // 22
  'fprem',       // 23
  'fprem1',      // 24
  'fptan',       // 25
  'frndint',     // 26
  'fscale',      // 27
  'fsin',        // 28
	'fsincos',     // 29
  'fsqrt',       // 2A
  'ftst',        // 2B
  'fxam',        // 2C
  'fxtract',     // 2D
  'fyl2x',       // 2E
  'fyl2xp1',     // 2F
	'hlt',         // 30
  'insb',        // 31
  'insw',        // 32
  'insd',        // 33
  'into',        // 34
  'invd',        // 35
  'iret',        // 36
  'iretd',       // 37
  'lahf',        // 38
	'leave',       // 39
  'lodsb',       // 3A
  'lodsw',       // 3B
  'lodsd',       // 3C
  'movsb',       // 3D
  'movsw',       // 3E
  'movsd',       // 3F
  'nop',         // 40
	'outsb',       // 41
  'outsw',       // 42
  'outsd',       // 43
  'popa',        // 44
  'popad',       // 45
  'popf',        // 46
  'popfd',       // 47
  'pusha',       // 48
	'pushad',      // 49
  'pushf',       // 4A
  'pushfd',      // 4B
  'ret',         // 4C
  'retf',        // 4D
  'sahf',        // 4E
  'scasb',       // 4F
  'scasw',       // 50
	'scasd',       // 51
  'stc',         // 52
  'std',         // 53
  'sti',         // 54
  'stosb',       // 55
  'stosw',       // 56
  'stosd',       // 57
  'wait',        // 58
	'wbinvd',      // 59
  'xlat',        // 5A
  'cpuid',       // 5B
  'rdmsr',       // 5C
  'rdpmc',       // 5D
  'rdtsc',       // 5E
  'ud2',         // 5F
  'wrmsr',       // 60
	'adc',         // 61
  'add',         // 62
  'and',         // 63
  'arpl',        // 64
  'bound',       // 65
  'bsf',         // 66
  'bsr',         // 67
  'bt',          // 68
  'btc',         // 69
  'btr',         // 6A
	'bts',         // 6B
  'cmp',         // 6C
  'cmpxchg',     // 6D
  'enter',       // 6E
  'or',          // 6F
  'sbb',         // 70
  'sub',         // 71
  'xor',         // 72
  'lar',         // 73
	'lea',         // 74
  'in',          // 75
  'out',         // 76
  'fadd',        // 77
  'faddp',       // 78
  'fmul',        // 79
  'fmulp',       // 7A
  'fdiv',        // 7B
  'fdivp',       // 7C
	'fdivr',       // 7D
  'fdivrp',      // 7E
  'fsub',        // 7F
  'fsubp',       // 80
  'fsubr',       // 81
  'fsubrp',      // 82
  'lds',         // 83
  'les',         // 84
	'lss',         // 85
  'lgs',         // 86
  'lfs',         // 87
  'imul',        // 88
  'lsl',         // 89
  'test',        // 8A
  'rcl',         // 8B
  'rcr',         // 8C
  'rol',         // 8D
  'ror',         // 8E
	'sar',         // 8F
  'shl',         // 90
  'shr',         // 91
  'xadd',        // 92
  'movsx',       // 93
  'movzx',       // 94
  'xchg',        // 95
  'mov',         // 96
  'shld',        // 97
	'shrd',        // 98
  'bswap',       // 99
  'call',        // 9A
  'dec',         // 9B
  'inc',         // 9C
  'div',         // 9D
  'idiv',        // 9E
  'fiadd',       // 9F
  'fbld',        // A0
	'fbstp',       // A1
  'fcom',        // A2
  'fcomp',       // A3
  'fcompp',      // A4
  'fucom',       // A5
  'fucomp',      // A6
  'fucompp',     // A7
	'ficom',       // A8
  'ficomp',      // A9
  'fidiv',       // AA
  'fidivr',      // AB
  'ffree',       // AC
  'fxch',        // AD
  'fild',        // AE
  'fist',        // AF
	'fistp',       // B0
  'fld',         // B1
  'fst',         // B2
  'fstp',        // B3
  'fldcw',       // B4
  'fstcw',       // B5
  'fldenv',      // B6
  'setalc',      // B7
	'fsave',       // B8
  'frstor',      // B9
  'retn',        // BA
  'fisub',       // BB
  'fisubr',      // BC
  'fimul',       // BD
  'mul',         // BE
  'neg',         // BF
	'not',         // C0
  'int',         // C1
  'int 3',       // C2
  'loop',        // C3
  'loopz',       // C4
  'loopnz',      // C5
  'ltr',         // C6
  'str',         // C7
  'invlpg',      // C8
  'jcxz',        // C9
	'jecxz',       // CA
  'lgdt',        // CB
  'lidt',        // CC
  'lldt',        // CD
  'lmsw',        // CE
  'sgdt',        // CF
  'sidt',        // D0
  'sldt',        // D1
  'smsw',        // D2
	'verr',        // D3
  'verw',        // D4
  'jmp',         // D5
  'j',           // D6
  'set',         // D7
  'push',        // D8
  'pop',         // D9
  'invalid',     // DA
  'fstenv',      // DB
  'fnstcw',      // DC
  'fstsw',       // DD
  'icebp',       // DE
  'sysenter',    // DF
  'sysexit',     // E0
  'fcmovb',      // E1
  'fcmove',      // E2
  'fcmovbe',     // E3
  'fcmovu',      // E4
  'fcmovnb',     // E5
  'fcmovne',     // E6
  'fcmovnbe',    // E7
  'fcmovnu',     // E8
  'cmov',        // E9
  'emms',        // EA
  'rsm',         // EB
  'movq',        // EC
  'packsswb',    // ED
  'paskssdw',    // EE
  'packuswb',    // EF
  'paddb',       // F0
  'paddw',       // F1
  'paddd',       // F2
  'paddsb',      // F3
  'paddsw',      // F4
  'paddusb',     // F5
  'paddusw',     // F6
  'pand',        // F7
  'pandn',       // F8
  'pcmpeqb',     // F9
  'pcmpeqw',     // FA
  'pcmpeqd',     // FB
  'pcmpgtb',     // FC
  'pcmpgtw',     // FD
  'pcmpgtd',     // FE
  'pmaddwd',     // FF
  'pmulhw',      // 100
  'pmullw',      // 101
  'por',         // 102
  'psllw',       // 103
  'pslld',       // 104
  'psllq',       // 105
  'psraw',       // 106
  'psrad',       // 107
  'psrlw',       // 108
  'psrld',       // 109
  'psrlq',       // 10A
  'psubb',       // 10B
  'psubw',       // 10C
  'psubd',       // 10D
  'psubsb',      // 10E
  'psubsw',      // 10F
  'psubusb',     // 110
  'psubusw',     // 111
  'punpckhbw',   // 112
  'punpckhwd',   // 113
  'punpckhdq',   // 114
  'punpcklbw',   // 115
  'punpcklwd',   // 116
  'punpckldq',   // 117
  'pxor',        // 118
  'movd',        // 119
  'cmpxchg8b',   // 11A
  'fxsave',      // 11B
  'fxrstor',     // 11C
  'addps',       // 11D
  'addss',       // 11E
  'andps',       // 11F
  'andnps',      // 120
  'cmpps',       // 121
  'cmpss',       // 122
  'comiss',      // 123
  'cvtpi2ps',    // 124
  'cvtsi2ss',    // 125
  'cvtps2pi',    // 126
  'cvtss2si',    // 127
  'cvttps2pi',   // 128
  'cvtss2si',    // 129
  'divps',       // 12A
  'divss',       // 12B
  'ldmxcsr',     // 12C
  'maxps',       // 12D
  'maxss',       // 12E
  'minps',       // 12F
  'minss',       // 130
  'movaps',      // 131
  'movhlps',     // 132
  'movlps',      // 133
  'movlhps',     // 134
  'movhps',      // 135
  'movmskps',    // 136
  'movups',       // 137
  'movss',      // 138
  'mulps',       // 139
  'mulss',       // 13A
  'orps',        // 13B
  'rcpps',       // 13C
  'rcpss',       // 13D
  'rsqrtps',     // 13E
  'rsqrtss',     // 13F
  'fhufps',      // 140
  'sqrtps',      // 141
  'sqrtss',      // 142
  'stmxcsr',     // 143
  'subps',       // 144
  'subss',       // 145
  'ucomiss',     // 146
  'unpckhps',    // 147
  'unpcklps',    // 148
  'xorps',       // 149
  'maskmovq',    // 14A
  'movntps',     // 14B
  'movntq',      // 14C
  'pavgb',       // 14D
  'pavgw',       // 14E
  'pextrw',      // 14F
  'pinsrw',      // 150
  'pmaxsw',      // 151
  'pmaxub',      // 152
  'pminsw',      // 153
  'pminub',      // 154
  'pmovmskb',    // 155
  'pmulhuw',     // 156
  'psadbw',      // 157
  'pshufw',      // 158
  'prefetcht0',  // 159
  'prefetcht1',  // 15A
  'prefetcht2',  // 15B
  'prefetchnta', // 15C
  'sfence'       // 15D
 );
